{$A+,B-,D-,E+,F-,I+,L-,N-,O-,R+,S+,V-}
{$M 30000,0,655360}


       { search all directories and convert *.bnk files to *.lmc files}

program bnk_lmc;

uses crt,dos;

type
  string80 = string[80];
var
  fn : string80;
  conv_ok : boolean;

const max_names = 500;
var
  fname : array[0..max_names] of string[14];
  total_names : word;
  ok:boolean;
  DirInfo : SearchRec;

procedure quicksort(Lo,Hi: integer);

procedure sort(l,r: integer);
var
  b:byte;
  i,
  j: integer;
  x,
  dummy:string[14];
begin
  i:=l;
  j:=r;
  x:=fname[(l+r) DIV 2];
  repeat
    while fname[i]<x do i:=i+1;
    while x<fname[j] do j:=j-1;
    if i<=j then
    begin
      dummy    := fname[i];
      fname[i] := fname[j];
      fname[j] := dummy;
      inc(i);
      dec(j);
    end;
  until i > j;
  if l < j then sort(l,j);
  if i < r then sort(i,r);
end;

begin {quicksort};
  sort(Lo,Hi);
end;

procedure get_names;
var
  d : dirstr;
  e : extstr;
begin
  total_names := 0;
  fillchar(fname,sizeof(fname),0);
  FindFirst(paramstr(1)+'*.bnk',$3F,dirInfo);
  while (DosError = 0) and (total_names < max_names) do
  begin
    if (dirinfo.attr = 0) or (dirinfo.attr=$20) then
    begin
      inc(total_names);
      fsplit(dirinfo.name,d,fname[total_names],e);
    end;
    FindNext(dirInfo);
  end;
  quicksort(1,total_names-1);
end;


procedure read_bnk_write_lmc(n:word);
type
  bnk_rec = record b,s:byte; x,y:integer; end;
  lmc_rec = record b,s:word; x,y:integer; end;
var
  bnk : bnk_rec;
  lmc : lmc_rec;
  f1  : file of bnk_rec;
  f2  : file of lmc_rec;
  i   : word;
begin
  ok := false;
  assign(f1,paramstr(1)+fname[n]+'.bnk');
  assign(f2,paramstr(2)+fname[n]+'.lmc');
  {$i-} reset(f1); {$i+}
  if ioresult <> 0 then exit;
  {$i-} rewrite(f2); {$i+}
  if ioresult <> 0 then
  begin
    close(f1);
    exit;
  end;
  for i:= 1 to filesize(f1) do
  begin
    read(f1,bnk);
    lmc.b := bnk.b;
    lmc.s := bnk.s;
    lmc.x := bnk.x;
    lmc.y := bnk.y;
    write(f2,lmc);
  end;
  close(f1);
  close(f2);
  ok := true;
end;

procedure convert;
var
  i:word;
begin
  get_names;
  for i := 1 to total_names do
  begin
    read_bnk_write_lmc(i);
    write(fname[i]:16);
  end;
end;

begin
  clrscr;
  convert;
end.


